# Locate KDL install directory

# This module defines
# Orocos-KDL_INSTALL where to find include, lib, bin, etc.
# Orocos-KDL_FOUND, is set to true

INCLUDE (FindPkgConfig)

IF ( PKG_CONFIG_FOUND )

  # set flag for whether items are required or not
  SET(IS_REQUIRED)
  IF (Orocos-KDL_FIND_REQUIRED)
	SET(IS_REQUIRED "REQUIRED")
  ENDIF (Orocos-KDL_FIND_REQUIRED)

  # find KDL itself
  set(ENV{PKG_CONFIG_PATH} "/work/a/ports/math/ros-geometry/work/geometry-1.4.2/kdl/lib/pkgconfig/")
  message( "Looking for KDL in: /work/a/ports/math/ros-geometry/work/geometry-1.4.2/kdl")
  pkg_search_module(Orocos-KDL ${IS_REQUIRED} orocos-kdl)
  
  IF( Orocos-KDL_FOUND )
    IF(NOT Orocos-KDL_FIND_QUIETLY)
      message("   Includes in: ${Orocos-KDL_INCLUDE_DIRS}")
      message(    "Compiler flags: ${Orocos-KDL_CFLAGS}")  
      message("   Libraries: ${Orocos-KDL_LIBRARIES}")
      message("   Libraries in: ${Orocos-KDL_LIBRARY_DIRS}")
      message("   Linker flags : ${Orocos-KDL_LD_FLAGS}")
      message("   Defines: ${Orocos-KDL_DEFINES}")
    ENDIF(NOT Orocos-KDL_FIND_QUIETLY)

	# find requested components (if any)
	foreach (COMPONENT ${Orocos-KDL_FIND_COMPONENTS})
	  string(TOUPPER ${COMPONENT} UCOMPONENT)

	  # we only handle toolkits (for now)
	  if (${COMPONENT} MATCHES "kdltk.*")

		# ensure we have any required variables
		IF (NOT OROCOS_TARGET)
		  MESSAGE(FATAL_ERROR "For toolkit support you must set OROCOS_TARGET (e.g. gnulinux, macosx, lxrt)")
		ENDIF (NOT OROCOS_TARGET)

		# variable names for this component (eg "KDLTK")
		SET(COMP_PREFIX "${UCOMPONENT}")

		# module name to search for (eg "orocos-kdltk-gnulinux")
		string(TOLOWER "orocos-${COMPONENT}-${OROCOS_TARGET}" COMP_MODULE)

		pkg_search_module(${COMP_PREFIX} ${IS_REQUIRED} ${COMP_MODULE})

	 else (${COMPONENT} MATCHES "kdltk.*")
	   MESSAGE(FATAL_ERROR "Unsupported component '${COMPONENT}'")
	 endif (${COMPONENT} MATCHES "kdltk.*")

	endforeach (COMPONENT ${Orocos-KDL_FIND_COMPONENTS})

  ELSE(Orocos-KDL_FOUND)  
    IF(Orocos-KDL_FIND_REQUIRED)
      MESSAGE(FATAL_ERROR "Could not find KDL")
    ENDIF(Orocos-KDL_FIND_REQUIRED)
  ENDIF ( Orocos-KDL_FOUND )
ELSE  ( PKG_CONFIG_FOUND )

  MESSAGE( FATAL_ERROR "Can't find KDL without pkgconfig !")

ENDIF ( PKG_CONFIG_FOUND )
